//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: lockit.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

String.prototype.get = function(p)
{
  return (match = this.match(new RegExp("[?|&]?" + p + "=([^&]*)"))) ? match[1] : null;
}

var lockitXHR;

function lockitLoadLangs(_title)
{
  if (!lockitXHR)
    lockitXHR = new XMLHttpRequest();

  with (lockitXHR)
  {
    open("GET", _title + ".txt", false);
    send(null);

    if (responseText)
    {
      try
      {
        return JSON.parse(responseText.replace(/[\r\n]/g, ''));
      }
      catch (e)
      {
        console.log(e);
      }
    }
  }

  return null;
}

function lockitGetLang()
{
  var lang = window.location.search.get("lang");

  if (!lang)
    lang = window.localStorage.getItem("xpromo.lang");

  if (!lang)
  {
    if (navigator.userLanguage)
      lang = navigator.userLanguage;
    else
    if (navigator.language)
      lang = navigator.language.split("-")[0];
  }

  return lang;  
}

function lockitGet(_data)
{
  if (_data)
  {
    var english = _data["lang.en"];
    var lang    = lockitGetLang();
    var result  = _data["lang." + lang];

    if (!result)
    {
      result = english;
      lang   = "en";
    }
    else
    if (result != english)
    {
      for (var k in english)
        if (!result.hasOwnProperty(k))
          result[k] = english[k];
    }

    if (result)
      result.lang = lang;

    return result;
  }

  return null;
}

var lockitCache = {};

function lockitLoad(_title)
{
  var result = lockitCache[_title];
  if (result == undefined)
  {
    result = lockitGet(lockitLoadLangs(_title));;
    lockitCache[_title] = result;
  }

  return result;
}

function lockitRenderData(_data)
{
  if (_data)
  {
    for (var sel in _data)
    {
      var elements = document.querySelectorAll(sel);
      for (var i in elements)
        elements[i].innerHTML = _data[sel];
    }
  }

  return _data;
}

var lockitThis = lockitLoad(document.title);
if ("title" in lockitThis)
{
  document.title = lockitThis["title"];
  delete lockitThis["title"];
}

function lockitRender()
{
  return lockitRenderData(lockitThis);
}

//
// Common utils
//

// Adds class name to element
function addClass(element, elClass) 
{
  var curr = element.className;
  if (!new RegExp(("(^|\\s)" + elClass + "(\\s|$)"), "i").test(curr)) 
  {
    element.className = curr + ((curr.length > 0) ? " " : "") + elClass;
  }
  return element;
}

// Removes class name from element
function removeClass(element, elClass) 
{
  if (elClass) 
  {
    element.className = element.className.replace(elClass, "");
  }
  else 
  {
    element.className = "";
    element.removeAttribute("class");
  }
  return element;
}
