//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------

var activeItem = 1;
var timerID    = 1;

var mainGames = gamesInit(xpromoGames).filter(function(element, index, array)
{
  // filter out duplicates
  for (i = 0; i < index; i++)
    if (array[i].id == element.id)
      return false;

  // create store link
  element.href = element.id + "/index.html";
  if (!makeStoreLink(element))
    return false;

  return true;
});

function makeStoreLink(_anchor)
{
  with (lockitXHR)
  {
    open("GET", _anchor.href, false);
    send(null);

    if (responseText)
    {
      try
      {
        var begin = responseText.indexOf("@ext(");
        if (begin != -1)
        {
          var end      = responseText.indexOf("\">", begin);
          _anchor.href = responseText.substring(begin, end);
          return true;
        }
      }
      catch (e)
      {
        console.log(e);
      }
    }
  }

  return false;
}

function mainRender(_banners)
{
  var data = {};
  data.banners = _banners;
  data.games = mainGames;

  var gamesBox = $p(".games-box ul");
  gamesBox.autoRender(data, {
      "li" : 
      {
        "game<-games" : 
        {
          "a@href"      : "game.href",
          ".name"       : "game.name",
          ".icon@style" : "background-image: url('#{game.id}/icon.png')"
        }
      }
    });

  // fixup width
  gamesBox[0].style.width = 134 * gamesBox[0].childElementCount + "px";

  var game = gamesLoadGame(xpromoGames, gamesSelfId());
  $p(".game-current").autoRender(game,
        {
          ".name"       : "name",
          ".icon@style" : "background-image: url('#{id}/icon.png')"
        }
    );

  $p(".banners-box").autoRender(data, {
      ".banner-item" : 
      {
        "banner<-banners" : 
        {
          "@id"         : function(arg) { return "banner-item-" + (arg.pos + 1); },
          "@href"       : "banner.href",
          "@style"      : function(arg) { return ((arg.pos == 0) ? "" : "display:none;") + arg.item.style; },
          "div.text"    : "banner.text",
          ".+"          : function(arg) { return arg.item.button ? ("<div class='button'><span>" + arg.item.button + "</span></div>") : ""; }
        }
      }
    });
}

function mainModal(_url)
{
  window.open(_url, "_blank", "width=800px, height=600px");
}

$(document).ready(function()
{
  setTimeout(function () { timerID = scrollerByTimeOut(); }, 7000);
  
  updateLayout();

  var userAgent = navigator.userAgent.toLowerCase();
  var hasScroll = (userAgent.indexOf("ipad") != -1 || userAgent.indexOf("iphone") != -1) && 
                  (userAgent.indexOf("os 5") != -1);

  if (!hasScroll)
    new iScroll($p(".games-box")[0], { vScroll : false });
});

$(window).resize(updateLayout);

function updateLayout()
{
  var zoom = (window.innerHeight / 768) * 100;
  document.body.style.zoom =  zoom + "%";
  document.body.style["font-size"] = document.body.style.zoom;
}

function clickEvent(event, target)
{
}

function scrollerByTimeOut() 
{
  var nextItem = (activeItem >= $('.banner-item').length) ? 1 : activeItem + 1;
  scroller(nextItem);
}

function scroller(aId) 
{
  if (activeItem != aId) 
  {
    $('#banner-item-' + activeItem).fadeOut(700);
    $('#banner-item-' + aId).fadeIn(700);
    activeItem = aId;
  }

  clearTimeout(timerID);
  timerID = setTimeout(function () 
  {
    scrollerByTimeOut()
  }, 7000);
}
